package com.televox;
public class TeleToken {

    static {
    System.loadLibrary("teletokenj");
    }
    //funkcje biblioteki teletokenj.dll
    public TeleToken(){

    }
    //--------------------------------------
    private native int GetVersion(int Ver[]);
    public int Version = 0;
    public int SubVersion = 0;
    public int ApiVersion = 0;
    public int GetVersion()
    {
        int[] Ver = new int[3];
        int ret;
        Version = 0;
        SubVersion = 0;
        ApiVersion = 0;
        ret = GetVersion(Ver);
        if (ret==TVTTS_OK)
        {
            Version = Ver[0];
            SubVersion = Ver[1];
            ApiVersion = Ver[2];
        }

        return ret;
    }
    
    
    //--------------------------------------
    private native int FindToken(int[] FindTokenTbl);

    private int Handle = 0;
    public int FeatureTblSize = 0;
    public int[] FeatureTbl = new int[TVTTTI_TABLE_SIZE];
    
    public int FindToken(int TimeOut, int OwnerID, int OwnerMask, int Skip)
    {
        int n, ret;
        int[] FindTokenTbl = new int[6+TVTTTI_TABLE_SIZE];

        FindTokenTbl[0]=0;    //uchwyt na token
        FindTokenTbl[1]=TimeOut;
        FindTokenTbl[2]=OwnerID;
        FindTokenTbl[3]=OwnerMask;
        FindTokenTbl[4]=Skip;
        FindTokenTbl[5]=TVTTTI_TABLE_SIZE;

        ZeroMemory(FeatureTbl, TVTTTI_TABLE_SIZE);
        ret = FindToken(FindTokenTbl);
        if (ret==TVTTS_OK)
        {
            Handle=FindTokenTbl[0];
            for (n=6; n<6+TVTTTI_TABLE_SIZE; n++)
                FeatureTbl[n-6]=FindTokenTbl[n];
            FeatureTblSize=FindTokenTbl[5];
        }
        
        return ret;
    }
    //--------------------------------------
    private native int FreeToken(int TokenH);
    public int FreeToken()
    {
        return FreeToken(Handle);
    }
    //--------------------------------------
    public int[] SerialNr = new int[4];
    private native int GetSerialNr(int[] SerialNrTbl);
    public int GetSerialNr(int TimeOut)
    {
        int ret,n;
        int[] GetSerialNrTbl = new int[6];
        
        GetSerialNrTbl[0]=Handle;
        GetSerialNrTbl[1]=TimeOut;
        
        for (n=0;n<4;n++) SerialNr[n] = 0;
        ret = GetSerialNr(GetSerialNrTbl);
        if (ret==TVTTS_OK) for (n=0;n<4;n++) SerialNr[n] = GetSerialNrTbl[n+2];
       
        return ret;
    }
    //--------------------------------------
    private native int StartSession(int TokenH, int TimeOut);
    public int StartSession(int TimeOut)
    {
        return StartSession(Handle, TimeOut);
    }
    //--------------------------------------
    public int[] SessionKey = new int[16];
    public int[] OutDataA = new int[16];
    public int[] OutDataB = new int[16];
    public int[] InDataA = new int[16];
    public int[] InDataB = new int[16];
    public int OutKey;
    public int InKey;
    private native int Talk(int[] TalkTbl);
    public int Talk(int TimeOut)
    {
        int n, ret;
        int[] TalkTbl = new int[3+16+16+1+32];

        TalkTbl[0]=Handle;    //uchwyt na token
        TalkTbl[1]=TimeOut;
        TalkTbl[2]=OutKey;
        //OutDataA
        for (n=0;n<16;n++) TalkTbl[3+n]=OutDataA[n];
        for (n=0;n<16;n++) TalkTbl[3+16+n]=OutDataB[n];

        TalkTbl[3+16+16]=InKey;
        for (n=0;n<32;n++) TalkTbl[3+16+16+1+n]=0;

        ZeroMemory(InDataA,16);
        ZeroMemory(InDataB,16);

        ret = Talk(TalkTbl);
        if (ret==TVTTS_OK)
        {
            for (n=0; n<16;n++)
            {
                InDataA[n]=TalkTbl[3+16+16+1+n];
                InDataB[n]=TalkTbl[3+16+16+1+16+n];
            }
            InKey=TalkTbl[3+16+16];
        }

        return ret;

    }    
    //--------------------------------------
    private native int EndSession(int TokenH);
    public int EndSession()
    {
        return EndSession(Handle);
    }
    //---------------------------------------------------------------------------
    // Stałe biblioteki
    public static final int TVTT_BLOCK_A                   = 0;                                   /* stała definująca numer bloku danych przy szyfrowaniu pierwszego bloku danych - na potrzeby funkcji generującej hasła tymczasowe */
    public static final int TVTT_BLOCK_B                   = 1;                                   /* stała definująca numer bloku danych przy szyfrowaniu drugiego bloku danych - na potrzeby funkcji generującej hasła tymczasowe */
    public static final int TVTT_PC2T                      = 0;                                   /* stała definująca kierunek przesłania wiadomości z PC do Tokenu - na potrzeby funkcji generującej hasła tymczasowe */
    public static final int TVTT_T2PC                      = 1;                                   /* stała definująca kierunek przesłania wiadomości z Tokenu do PC - na potrzeby funkcji generującej hasła tymczasowe */

    public static final int TVTT_RAND_INIT_TBL_SIZE        = (16*4);                              /* stała definiująca rozmiar tablicy inicjującej generator liczb pseudolosowych */

    public static final int TVTTS_OK                       = 0;
    //---------------------------------------------------------------------------
    // Kody błędów zwracane przez DLL

    public static final int TVTTS_INVALID_HANDLE           = 0x0100;
    public static final int TVTTS_NULL_PTR                 = 0x0200;
    public static final int TVTTS_BAD_PARAM                = 0x0300;
    public static final int TVTTS_TOO_MANY_OPEN_TOKENS     = 0x0400;
    public static final int TVTTS_USB_DOES_NOT_EXIST       = 0x0500;
    public static final int TVTTS_TOKEN_NOT_FOUND          = 0x0600;
    public static final int TVTTS_TIME_OUT                 = 0x0700;
    public static final int TVTTS_SEQ_EXPIRED              = 0x0800;
    public static final int TVTTS_ALREADY_OPENED           = 0x0900;
    public static final int TVTTS_UNKNOWN_ERROR            = 0x1000;
    public static final int TVTTS_DLL_INIT_FAILED          = 0xFF00;

    //---------------------------------------------------------------------------

    // kody statusu Tokenu:
    public static final int TVTTS_NO_OPEN                  = 0x11;
    public static final int TVTTS_EXPIRED                  = 0x12;
    public static final int TVTTS_DAMAGED                  = 0x13;

    public static final int TVTTS_NOT_SUPPORTED            = 0x21;
    public static final int TVTTS_OUT_OF_RANGE             = 0x22;
    public static final int TVTTS_PROTECTION_NOT_SUPPORTED = 0x23;

    public static final int TVTTS_PASS_NOT_PERMITTED       = 0x31;
    public static final int TVTTS_NOT_PERMITTED            = 0x32;
    public static final int TVTTS_ACCESS_EXPIRED           = 0x33;

    //---------------------------------------------------------------------------
    // definicja pól tablicy opisującej możliwości tokenu
    public static final int TVTTTI_ID                      = 0;
    public static final int TVTTTI_NV_MEM_SIZE             = 1;
    public static final int TVTTTI_RAM_SIZE                = 2;
    public static final int TVTTTI_PROTECT_MEM_SIZE        = 3;
    public static final int TVTTTI_PASS_TABLE_SIZE         = 4;
    public static final int TVTTTI_BITS_PER_PASS           = 5;
    public static final int TVTTTI_COUNTERS                = 6;
    public static final int TVTTTI_BITS_PER_COUNTER        = 7;
    public static final int TVTTTI_EXT_VERSION             = 8;

    public static final int TVTTTI_TABLE_SIZE              = 9;

    //---------------------------------------------------------------------------
    // definicja standardowych pól w drugim bloku danych
    public static final int TVTTD_CMD                      = 0;
    public static final int TVTTD_STATUS                   = 0;
    public static final int TVTTD_PARAM1                   = 1;
    public static final int TVTTD_PARAM2                   = 2;
    public static final int TVTTD_PARAM3                   = 3;
    public static final int TVTTD_AUTH                     = 4;

    //---------------------------------------------------------------------------
    // kody rozkazów tokenu
    public static final int TVTTC_OPEN                      = 0x01;
    public static final int TVTTC_CLOSE                     = 0x02;
    public static final int TVTTC_FORMAT                    = 0x0F;

    public static final int TVTTC_NVMEM_READ                = 0x11;
    public static final int TVTTC_NVMEM_WRITE               = 0x12;
    public static final int TVTTC_NVMEM_WRITE_PROTECT       = 0x13;
    public static final int TVTTC_NVMEM_PROTECT             = 0x14;
    public static final int TVTTC_NVMEM_DECRYPT_WRITE       = 0x15;

    public static final int TVTTC_VMEM_READ                 = 0x91;
    public static final int TVTTC_VMEM_WRITE                = 0x92;

    public static final int TVTTC_ENCRYPT                   = 0x21;
    public static final int TVTTC_DECRYPT                   = 0x22;

    public static final int TVTTC_CNT_READ                  = 0x31;
    public static final int TVTTC_CNT_INC_READ              = 0x32;
    public static final int TVTTC_CNT_DEC_READ              = 0x33;
    public static final int TVTTC_CNT_WRITE                 = 0x34;
    public static final int TVTTC_CNT_INC_ENCRYPT_READ      = 0x35;
    public static final int TVTTC_CNT_WRITE_CONFIG          = 0x36;
    public static final int TVTTC_CNT_SET_CONFIG            = 0x37;
    public static final int TVTTC_CNT_CLR_CONFIG            = 0x38;
    public static final int TVTTC_CNT_DECRYPT_WRITE         = 0x39;

    public static final int TVTTC_PASS_WRITE                = 0x41;
    public static final int TVTTC_PASS_WRITE_CONFIG         = 0x42;
    public static final int TVTTC_PASS_SET_CONFIG           = 0x43;
    public static final int TVTTC_PASS_CLR_CONFIG           = 0x44;

    // podrozkazy do rozkazu TVTTC_CNT_DECRYPT_WRITE
    public static final int TVTTCS_CNT_WRITE                = 0x00;
    public static final int TVTTCS_CNT_INC                  = 0x01;
    public static final int TVTTCS_CNT_DEC                  = 0x02;

    //---------------------------------------------------------------------------
    // bity konfiguracji haseł

    public static final int TVTTPC0_TOKEN                   = 0x01;
    public static final int TVTTPC0_PASS_WRITE              = 0x02;
    public static final int TVTTPC0_PASS_CONFIG             = 0x04;
    public static final int TVTTPC0_MEM_READ                = 0x08;
    public static final int TVTTPC0_MEM_WRITE               = 0x10;
    public static final int TVTTPC0_ENCRYPT                 = 0x20;
    public static final int TVTTPC0_DECRYPT                 = 0x40;
    public static final int TVTTPC0_DECRYPT_WRITE           = 0x80;

    public static final int TVTTPC1_CNT_READ                = 0x01;
    public static final int TVTTPC1_CNT_WRITE               = 0x02;
    public static final int TVTTPC1_CNT_CONFIG              = 0x04;
    public static final int TVTTPC1_ENCRYPT_PASS            = 0x08;
    public static final int TVTTPC1_DECRYPT_PASS            = 0x10;
    public static final int TVTTPC1_CNT_ENCRYPT_PASS        = 0x20;
    public static final int TVTTPC1_WRITE_ENABLED           = 0x40;
    public static final int TVTTPC1_CONFIG_ENABLED          = 0x80;

    //---------------------------------------------------------------------------
    // bity konfiguracji liczników

    public static final int TVTTCC0_WRITE                   = 0x01;
    public static final int TVTTCC0_READ                    = 0x02;
    public static final int TVTTCC0_INC_READ                = 0x04;
    public static final int TVTTCC0_DEC_READ                = 0x08;
    public static final int TVTTCC0_INC_ENCRYPT_READ        = 0x10;
    public static final int TVTTCC0_STOP_AT_ZERO            = 0x20;
    public static final int TVTTCC0_NVMEM_READ              = 0x40;
    public static final int TVTTCC0_NVMEM_WRITE             = 0x80;

    public static final int TVTTCC1_PASS                    = 0x01;
    public static final int TVTTCC1_NVMEM_DECRYPT_WRITE     = 0x02;
    public static final int TVTTCC1_CONFIG_ENABLED          = 0x80;
    
    //rijndael

    private static final int ROUNDS			= 10;
    private static final int BC				= 4;
    private static final int KC				= 4;
    private static final int MAXBC			= 4;
    private static final int MAXKC			= 4;
    private static final int MAXROUNDS			= ROUNDS + 1;

    private static final int SC				= 0;
    private static final int OPERATION_FAILED		= -1;
    private static final int SUCCESS			= 0;

    private static int[] Logtable = new int[] {
            0,   0,  25,   1,  50,   2,  26, 198,  75, 199,  27, 104,  51, 238, 223,   3,
            100,   4, 224,  14,  52, 141, 129, 239,  76, 113,   8, 200, 248, 105,  28, 193,
            125, 194,  29, 181, 249, 185,  39, 106,  77, 228, 166, 114, 154, 201,   9, 120,
            101,  47, 138,   5,  33,  15, 225,  36,  18, 240, 130,  69,  53, 147, 218, 142,
            150, 143, 219, 189,  54, 208, 206, 148,  19,  92, 210, 241,  64,  70, 131,  56,
            102, 221, 253,  48, 191,   6, 139,  98, 179,  37, 226, 152,  34, 136, 145,  16,
            126, 110,  72, 195, 163, 182,  30,  66,  58, 107,  40,  84, 250, 133,  61, 186,
             43, 121,  10,  21, 155, 159,  94, 202,  78, 212, 172, 229, 243, 115, 167,  87,
            175,  88, 168,  80, 244, 234, 214, 116,  79, 174, 233, 213, 231, 230, 173, 232,
             44, 215, 117, 122, 235,  22,  11, 245,  89, 203,  95, 176, 156, 169,  81, 160,
            127,  12, 246, 111,  23, 196,  73, 236, 216,  67,  31,  45, 164, 118, 123, 183,
            204, 187,  62,  90, 251,  96, 177, 134,  59,  82, 161, 108, 170,  85,  41, 157,
            151, 178, 135, 144,  97, 190, 220, 252, 188, 149, 207, 205,  55,  63,  91, 209,
             83,  57, 132,  60,  65, 162, 109,  71,  20,  42, 158,  93,  86, 242, 211, 171,
             68,  17, 146, 217,  35,  32,  46, 137, 180, 124, 184,  38, 119, 153, 227, 165,
            103,  74, 237, 222, 197,  49, 254,  24,  13,  99, 140, 128, 192, 247, 112,   7,
    };
    private static final int[] Alogtable = new int[] {
              1,   3,   5,  15,  17,  51,  85, 255,  26,  46, 114, 150, 161, 248,  19,  53,
             95, 225,  56,  72, 216, 115, 149, 164, 247,   2,   6,  10,  30,  34, 102, 170,
            229,  52,  92, 228,  55,  89, 235,  38, 106, 190, 217, 112, 144, 171, 230,  49,
             83, 245,   4,  12,  20,  60,  68, 204,  79, 209, 104, 184, 211, 110, 178, 205,
             76, 212, 103, 169, 224,  59,  77, 215,  98, 166, 241,   8,  24,  40, 120, 136,
            131, 158, 185, 208, 107, 189, 220, 127, 129, 152, 179, 206,  73, 219, 118, 154,
            181, 196,  87, 249,  16,  48,  80, 240,  11,  29,  39, 105, 187, 214,  97, 163,
            254,  25,  43, 125, 135, 146, 173, 236,  47, 113, 147, 174, 233,  32,  96, 160,
            251,  22,  58,  78, 210, 109, 183, 194,  93, 231,  50,  86, 250,  21,  63,  65,
            195,  94, 226,  61,  71, 201,  64, 192,  91, 237,  44, 116, 156, 191, 218, 117,
            159, 186, 213, 100, 172, 239,  42, 126, 130, 157, 188, 223, 122, 142, 137, 128,
            155, 182, 193,  88, 232,  35, 101, 175, 234,  37, 111, 177, 200,  67, 197,  84,
            252,  31,  33,  99, 165, 244,   7,   9,  27,  45, 119, 153, 176, 203,  70, 202,
             69, 207,  74, 222, 121, 139, 134, 145, 168, 227,  62,  66, 198,  81, 243,  14,
             18,  54,  90, 238,  41, 123, 141, 140, 143, 138, 133, 148, 167, 242,  13,  23,
             57,  75, 221, 124, 132, 151, 162, 253,  28,  36, 108, 180, 199,  82, 246,   1,
    };

    private static final int[] S = new int[] {
             99, 124, 119, 123, 242, 107, 111, 197,  48,   1, 103,  43, 254, 215, 171, 118,
            202, 130, 201, 125, 250,  89,  71, 240, 173, 212, 162, 175, 156, 164, 114, 192,
            183, 253, 147,  38,  54,  63, 247, 204,  52, 165, 229, 241, 113, 216,  49,  21,
              4, 199,  35, 195,  24, 150,   5, 154,   7,  18, 128, 226, 235,  39, 178, 117,
              9, 131,  44,  26,  27, 110,  90, 160,  82,  59, 214, 179,  41, 227,  47, 132,
             83, 209,   0, 237,  32, 252, 177,  91, 106, 203, 190,  57,  74,  76,  88, 207,
            208, 239, 170, 251,  67,  77,  51, 133,  69, 249,   2, 127,  80,  60, 159, 168,
             81, 163,  64, 143, 146, 157,  56, 245, 188, 182, 218,  33,  16, 255, 243, 210,
            205,  12,  19, 236,  95, 151,  68,  23, 196, 167, 126,  61, 100,  93,  25, 115,
             96, 129,  79, 220,  34,  42, 144, 136,  70, 238, 184,  20, 222,  94,  11, 219,
            224,  50,  58,  10,  73,   6,  36,  92, 194, 211, 172,  98, 145, 149, 228, 121,
            231, 200,  55, 109, 141, 213,  78, 169, 108,  86, 244, 234, 101, 122, 174,   8,
            186, 120,  37,  46,  28, 166, 180, 198, 232, 221, 116,  31,  75, 189, 139, 138,
            112,  62, 181, 102,  72,   3, 246,  14,  97,  53,  87, 185, 134, 193,  29, 158,
            225, 248, 152,  17, 105, 217, 142, 148, 155,  30, 135, 233, 206,  85,  40, 223,
            140, 161, 137,  13, 191, 230,  66, 104,  65, 153,  45,  15, 176,  84, 187,  22,
    };

    private static final int[] Si = new int[] {
             82,   9, 106, 213,  48,  54, 165,  56, 191,  64, 163, 158, 129, 243, 215, 251,
            124, 227,  57, 130, 155,  47, 255, 135,  52, 142,  67,  68, 196, 222, 233, 203,
             84, 123, 148,  50, 166, 194,  35,  61, 238,  76, 149,  11,  66, 250, 195,  78,
              8,  46, 161, 102,  40, 217,  36, 178, 118,  91, 162,  73, 109, 139, 209,  37,
            114, 248, 246, 100, 134, 104, 152,  22, 212, 164,  92, 204,  93, 101, 182, 146,
            108, 112,  72,  80, 253, 237, 185, 218,  94,  21,  70,  87, 167, 141, 157, 132,
            144, 216, 171,   0, 140, 188, 211,  10, 247, 228,  88,   5, 184, 179,  69,   6,
            208,  44,  30, 143, 202,  63,  15,   2, 193, 175, 189,   3,   1,  19, 138, 107,
             58, 145,  17,  65,  79, 103, 220, 234, 151, 242, 207, 206, 240, 180, 230, 115,
            150, 172, 116,  34, 231, 173,  53, 133, 226, 249,  55, 232,  28, 117, 223, 110,
             71, 241,  26, 113,  29,  41, 197, 137, 111, 183,  98,  14, 170,  24, 190,  27,
            252,  86,  62,  75, 198, 210, 121,  32, 154, 219, 192, 254, 120, 205,  90, 244,
             31, 221, 168,  51, 136,   7, 199,  49, 177,  18,  16,  89,  39, 128, 236,  95,
             96,  81, 127, 169,  25, 181,  74,  13,  45, 229, 122, 159, 147, 201, 156, 239,
            160, 224,  59,  77, 174,  42, 245, 176, 200, 235, 187,  60, 131,  83, 153,  97,
             23,  43,   4, 126, 186, 119, 214,  38, 225, 105,  20,  99,  85,  33,  12, 125,
    };

    private static final int[][] iG = new int[][] {
            {0x0e, 0x09, 0x0d, 0x0b},
            {0x0b, 0x0e, 0x09, 0x0d},
            {0x0d, 0x0b, 0x0e, 0x09},
            {0x09, 0x0d, 0x0b, 0x0e}
    };

    private static final int[] rcon = new int[] {
            0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x1b, 0x36, 0x6c, 0xd8, 0xab,
            0x4d, 0x9a, 0x2f, 0x5e, 0xbc, 0x63, 0xc6, 0x97, 0x35, 0x6a, 0xd4, 0xb3, 0x7d,
            0xfa, 0xef, 0xc5, 0x91,
    };

    private static final int[][][] shifts = new int[][][] {
            {
                    {0, 0},
                    {1, 3},
                    {2, 2},
                    {3, 1}
            },

            {
                    {0, 0},
                    {1, 5},
                    {2, 4},
                    {3, 3}
            },

            {
                    {0, 0},
                    {1, 7},
                    {3, 5},
                    {4, 4}
            }
    };

    static private int mul(int a, int b)
    {
       /* multiply two elements of GF(2^m)
            * needed for MixColumn and InvMixColumn
            */
            if ((a != 0) && (b != 0)) return Alogtable[(Logtable[a] + Logtable[b])%255];
            else return 0;
    }

    static private void AddRoundKey(int[][] a, final int[][] rk)
    {
            /* Exor corresponding text input and round key input ints
             */
            int i, j;

            for(i = 0; i < 4; i++)
                    for(j = 0; j < BC; j++) a[i][j] ^= rk[i][j];
    }

    static private void Substitution(int[][] a, final int[] box)
    {
            /* Replace every byte of the input by the byte at that place
             * in the nonlinear S-box.
                     * This routine implements SubBytes and InvSubBytes
             */
            int i, j;

            for(i = 0; i < 4; i++)
                    for(j = 0; j < BC; j++)
                    {
                        a[i][j] = box[a[i][j]] ;
                    }
    }

    static private void MixColumns(int[][] a)
    {
                    /* Mix the four bytes of every column in a linear way
             */
            int[][] b = new int [4][MAXBC];
            int i, j;

            for(j = 0; j < BC; j++) {
                    for(i = 0; i < 4; i++){

                            b[i][j] = (mul(2, a[i][j])
                                    ^ mul(3, a[(i + 1) % 4][j])
                                    ^ a[(i + 2) % 4][j]
                                    ^ a[(i + 3) % 4][j]);
                    }
            }

            for(i = 0; i < 4; i++)
                    for(j = 0; j < BC; j++) a[i][j] = b[i][j];
    }

    static private void InvMixColumns(int[][] a)
    {
            /* Mix the four bytes of every column in a linear way
             * This is the opposite operation of Mixcolumns
             */
            int[][] b = new int [4][MAXBC];
            int i, j;

            for(j = 0; j < BC; j++)
                    for(i = 0; i < 4; i++)
                            b[i][j] = (int) (mul(0xe,a[i][j])
                                    ^ mul(0xb,a[(i + 1) % 4][j])
                                    ^ mul(0xd,a[(i + 2) % 4][j])
                                    ^ mul(0x9,a[(i + 3) % 4][j]));
            for(i = 0; i < 4; i++)
                    for(j = 0; j < BC; j++) a[i][j] = b[i][j];
    }

    static private void ShiftRows(int[][] a, final int d)
    {
            /* Row 0 remains unchanged
             * The other three rows are shifted a variable amount
             */
            int[] tmp = new int[MAXBC];
            int i, j;

            for(i = 1; i < 4; i++) {
                    for(j = 0; j < BC; j++)
                        tmp[j] = a[i][(j + shifts[SC][i][d]) % BC];
                    for(j = 0; j < BC; j++) a[i][j] = tmp[j];
            }
    }

    static private int rijndaelKeySched (int[][] k, int[][][] W)
    {
            /* Calculate the necessary round keys
             * The number of calculations depends on keyBits and blockBits
             */
            int i, j, t, rconpointer = 0;
            int[][] tk = new int[4][MAXKC];

            for(j = 0; j < KC; j++)
                    for(i = 0; i < 4; i++)
                            tk[i][j] = k[i][j];

            t = 0;
            /* copy values into round key array */
            for(j = 0; (j < KC) && (t < (ROUNDS+1)*BC); j++, t++)
                    for(i = 0; i < 4; i++)
                            W[t / BC][i][t % BC] = tk[i][j];

            while (t < (ROUNDS+1)*BC) {
            /* while not enough round key material calculated */
            /* calculate new values */
                    for(i = 0; i < 4; i++)
                            tk[i][0] ^= S[tk[(i+1)%4][KC-1]];

                    tk[0][0] ^= rcon[rconpointer++];

                    if (KC != 8)
                            for(j = 1; j < KC; j++)
                                    for(i = 0; i < 4; i++) tk[i][j] ^= tk[i][j-1];

                    /* copy values into round key array */
                    for(j = 0; (j < KC) && (t < (ROUNDS+1)*BC); j++, t++)
                            for(i = 0; i < 4; i++) W[t / BC][i][t % BC] = tk[i][j];
            }

            return 0;
    }


    public int rijndaelEncrypt(final int [] keyTab, int [] data)
    {
            /* Encryption of one block.
             */
            int r, i, j;
            int[][][] rk = new int[MAXROUNDS+1][4][MAXBC];
            int ptr;
            int[][] dt = new int[4][MAXBC];
            int[][] kt = new int[4][MAXBC];


            //Table conversion
            ptr = 0;
            for (i = 0; i < 4; i++)
                    for (j = 0; j < 4; j++) {
                            kt[i][j] = keyTab[ptr];
                            dt[i][j] = data[ptr];
                            ptr++;
                    }            

            if (rijndaelKeySched(kt, rk) != 0) return(OPERATION_FAILED);

            /* begin with a key addition
             */
            
            AddRoundKey(dt, rk[0]);
            
            /* ROUNDS-1 ordinary rounds
             */
            
            for(r = 1; r < ROUNDS; r++) {
                    Substitution(dt, S);
                    ShiftRows(dt, (int) 0);
                    MixColumns(dt);
                    AddRoundKey(dt, rk[r]);
            }

            /* Last round is special: there is no MixColumns
             */
            Substitution(dt, S);
            ShiftRows(dt, (int) 0);
            AddRoundKey(dt, rk[ROUNDS]);


            //Table conversion
            ptr = 0;
            for (i = 0; i < 4; i++) {
                    for (j = 0; j < 4; j++) {
                            data[ptr] = dt[i][j];
                            ptr++;
                    }
            }

            return (SUCCESS);
    }


    public int rijndaelDecrypt(final int[] keyTab, int[] data)
    {
            int r, i, j;
            int[][][] rk = new int[MAXROUNDS+1][4][MAXBC];
            int ptr;
            int[][] dt = new int[4][MAXBC];
            int[][] kt = new int[4][MAXBC];

            //Table conversion
            ptr = 0;
            for (i = 0; i < 4; i++) {
                    for (j = 0; j < 4; j++) {
                            kt[i][j] = keyTab[ptr];
                            dt[i][j] = data[ptr];
                            ptr++;
                    }
            }

            if (rijndaelKeySched(kt, rk) != 0) return(OPERATION_FAILED);

            /* To decrypt: apply the inverse operations of the encrypt routine,
             *             in opposite order
             *
             * (AddRoundKey is an involution: it 's equal to its inverse)
             * (the inverse of Substitution with table S is Substitution with
                     *           the inverse table of S)
             * (the inverse of ShiftRows is ShiftRows over a suitable distance)
             */

                    /* First the special round:
             *   without InvMixColumns
             *   with extra AddRoundKey
             */
            AddRoundKey(dt, rk[ROUNDS]);
            Substitution(dt, Si);
            ShiftRows(dt, (int)1);

            /* ROUNDS-1 ordinary rounds
             */
            for(r = ROUNDS-1; r > 0; r--) {
                    AddRoundKey(dt, rk[r]);
                    InvMixColumns(dt);
                    Substitution(dt, Si);
                    ShiftRows(dt, (int)1);
            }

            /* End with the extra key addition
             */

            AddRoundKey(dt, rk[0]);

            //Table conversion
            ptr = 0;
            for (i = 0; i < 4; i++) {
                    for (j = 0; j < 4; j++) {
                            data[ptr] = dt[i][j];
                            ptr++;
                    }
            }

            return (SUCCESS);
    }

//END rijndael
//-----------------------------------------------------

    static public int[] RandKeyA                     = new int[16];       // generator liczb pseudolosowych - pierwsza połowa klucza generatora
    static public int[] RandKeyB                     = new int[16];       // generator liczb pseudolosowych - pierwsza połowa klucza generatora
    static public int[] RandCnt                      = new int[16];       // generator liczb pseudolosowych - licznik wywołań generatora liczb pseudolosowych
    static public int[] RandRand                     = new int[16*32];    // generator liczb pseudolosowych - bufor na kolejkę zdarzeń losowych
    static public int[] RandRandNr                   = new int[256];      // generator liczb pseudolosowych - licznik kolejkowania zdarzeń losowych
    static public int[] RandRandCnt                  = new int[32];       // generator liczb pseudolosowych - licznik zdarzeń w kolejkach


    /*****************************************************************************
    Funkcja liczy blok kontrolny wiadomości i umieszcza go w drugim bloku danych
    We:
            Adresy na oba bloki danych
    Wy:
            wyliczony blok autoryzacji zapisany do drugiego bloku danych

    *****************************************************************************/
    public void Calc(final int [] DataA, int [] DataB)
    {
            // wypełnienie bloku kontrolnego wartoťci¦ 0xFF
            int DstPtr = 0;
            while (DstPtr<12) {
                    DataB[TVTTD_AUTH+DstPtr] = 0xFF;
                    DstPtr++;
            }

            // dołączenie do obszaru kontrolnego, danych pierwszego bloku danych
            DstPtr = 0;
            int SrcPtr=0;
            while (SrcPtr<16) {
                    DataB[TVTTD_AUTH+DstPtr] ^= DataA[SrcPtr];
                    DstPtr = (DstPtr+1)%12;
                    SrcPtr++;
            }

            // dołączenie do obszaru kontrolnego, danych drugiego bloku danych
            SrcPtr = 0;
            while (SrcPtr<TVTTD_AUTH) {
                    DataB[TVTTD_AUTH+DstPtr] ^= DataB[SrcPtr];
                    DstPtr = (DstPtr+1)%12;
                    SrcPtr++;
            }
    }

    /*****************************************************************************
    Funkcja sprawdza poprawnoťŠ bloku kontrolnego wiadomoťci
    We:
            Adresy na oba bloki danych
    Wy:
            0 - blok kontrolny poprawny lub !0 - blok kontrolny nie poprawny

    *****************************************************************************/
    public int Check(final int[] DataA, int[] DataB)
    {
            // "usunięcie" z obszaru kontrolnego, danych pierwszego bloku danych
            int DstPtr = 0;
            int SrcPtr = 0;
            while (SrcPtr<16) {
                    DataB[TVTTD_AUTH+DstPtr] ^= DataA[SrcPtr];
                    DstPtr = (DstPtr+1)%12;
                    SrcPtr++;
            }

            // "usunięcie" z obszaru kontrolnego, danych drugiego bloku danych
            SrcPtr = 0;
            while (SrcPtr<TVTTD_AUTH) {
                    DataB[TVTTD_AUTH+DstPtr] ^= DataB[SrcPtr];
                    DstPtr = (DstPtr+1)%12;
                    SrcPtr++;
            }

            // sprawdzenie czy blok kontrolny wypełniony wartością 0xFF
            DstPtr = 0;
            while (DstPtr<12) {
                    if (DataB[TVTTD_AUTH+DstPtr] != 0xFF) return(1);                // błąd w bloku kontrolnym
                    DstPtr++;
            }

            return(0);                                                          // blok kontrolny poprawny
    }

    /*****************************************************************************
    Funkcja wylicza klucz sesji
    We:
            Adres na wyliczony klucz sesji (adres na tablicŕ docelow¦)
            Has-o PC
            Tablica losowa PC
            Has-o Tokenu
            Tablica losowa Tokenu
    Wy:
            wyliczony klucz sesji wpisany do podanej tablicy

    *****************************************************************************/
    public void CalcSessionKey     (int[] SessionKey,
                                    int[] PassPC,
                                    int[] RandPC,
                                    int[] PassT,
                                    int[] RandT)
    {
            int[] Data = new int[16];

            int i = 0;                                                          // skopiowanie tablicy losowej PC do bufora
            while(i<16) {
                    Data[i] = RandPC[i];
                    i++;
            }

            rijndaelEncrypt(PassT, Data);                                       // zaszyfrowanie tablicy losowej PC hasłem Tokenu

            i = 0;                                                              // przepisanie uzyskanej części klucza do tablicy klucza sesji
            while (i<16) {
                    SessionKey[i] = Data[i];
                    i++;
            }

            i = 0;                                                              // skopiowanie tablicy losowej Tokenu do bufora
            while (i<16) {
                    Data[i] = RandT[i];
                    i++;
            }

            rijndaelEncrypt(PassPC, Data);                                      // zaszyfrowanie tablicy losowej Tokenu hasłem PC

            i = 0;                                                              // połączenie pierwszej części klucza sesji z uzyskaną drugą częścią klucza sesji
            while (i<16) {
                    SessionKey[i] ^= Data[i];
                    i++;
            }

            i = 0;                                                              // wyczyszczenie bufora pomocniczego
            while (i<16) {
                    Data[i] = 0;
                    i++;
            }
    }

    /*****************************************************************************
    Funkcja rozszyfrowuje lub szyfruje podany blok danych
    We:
            Adres na blok do zaszyfrowania
            Klucza szyfrowania wiadomoťci
            Has-o sesji
            Numer bloku danych (0-blok pierwszy, 1-blok drugi)
            Kierunek przesy-ania wiadomoťci (0 - PC->Token, 1 - Token->PC)
    Wy:
            zaszyfrowany blok danych

    *****************************************************************************/
    public void CryptBlock     (int [] Block, int Key,
                                int [] Pass, int BlockNr,
                                int Direction)
    {
            int[] HashTable = new int[16];

            if (Key == 0) return;                                               // Key=0 jest znacznikiem wiadomości nieszyfrowanej -> wyjście

            int i = 0;                                                          // wyczyszczenie tablicy mieszaj¦cej
            while (i<16) {
                    HashTable[i]=0;
                    i++;
            }

            HashTable[0] = Key & 0xFF;                                          // przygotowanie do generowania klucza tymczasowego - wpisanie klucza szyfrowania wiadomoťci do tablicy wynikowej
            Key = Key>>8;
            HashTable[1] = Key & 0xFF;
            Key = Key>>8;
            HashTable[2] = Key & 0xFF;

            HashTable[3] = BlockNr & 0xFF;                                      // przygotowanie do gewnerowania klucza tymczasowego - do-¦czenie numeru bloku danych
            HashTable[4] = Direction & 0xFF;                                    // przygotowanie do gewnerowania klucza tymczasowego - do-¦czenie znacznika kierunku przesy-u wiadomoťci
            rijndaelEncrypt(Pass, HashTable);                                   // wygenerowanie hasła tymczasowego

            i=0;                                                                // rozszyfrowanie lub zaszyfrowanie bloku oraz wyczyszczenie tablicy mieszaj¦cej
            while (i<16) {
                    Block[i] ^= HashTable[i];
                    HashTable[i] = 0;
                    i++;
            }
    }

    /*****************************************************************************
    Funkcja inicjuje generator liczb pseudolosowych
    We:
            Adres na blok danych inicjujących

    *****************************************************************************/
    public void RandInit(int[][] Init)
    {
            int n;

            // rozszyfrowanie tablic
            n = 1;
            while (n<4) {
                    rijndaelDecrypt(Init[0], Init[n]);
                    n++;
            }

            // usunięcie mieszania tablic
            n = 16;
            while(n<(16*4)) {
                    Init[n/16][n%16] ^= n & 0xFF;
                    n++;
            }

            // przepisanie danych z bloku do tablic
            n=0;
            while (n<16) {
                    RandKeyA[n] = Init[1][n];
                    RandKeyB[n] = Init[2][n];
                    RandCnt[n] = Init[3][n];
                    n++;
            }
    }

    /*****************************************************************************
    Funkcja zwraca blok danych do użycia przy następnej inicjalizacji generatora
            liczb pseudolosowych
    We:
            Adres na blok do którego zapis danych opisujących stan generatora
    Wy:
            Blok danych opisujących stan generatora

    *****************************************************************************/
    public void RandGetInit(int[][] Init)
    {
            Rand(Init[0], 0);
            Rand(Init[1], 0);
            Rand(Init[2], 0);
            Rand(Init[3], 0);
    }

    /*****************************************************************************
    Funkcja dodaje zdarzenia losowe do generatora liczb pseudolosowych
    We:
            Numer źródła zdarzeń losowych
            Wartość zdarzenia

    *****************************************************************************/
    public void Randomize(int SrcNr, int Data)
    {
            int[] Buff = new int[16];
            int[] Buf2 = new int[16];
            int n;
            int RandOffset;

            // zwiększenie licznika danych w kolejce
            if (RandRandCnt[RandRandNr[SrcNr&0xFF]&31]!=0xFFFFFFFF)
                    (RandRandCnt[RandRandNr[SrcNr&0xFF]&31])++;

            // wyliczenie offsetu na kolejkę i zwiększenie licznika kolejek
            RandOffset = (int)((RandRandNr[SrcNr&0xFF]&31)*16);
            RandRandNr[SrcNr] = ((RandRandNr[SrcNr]+1)&31) & 0xFF;

            // wyczyszczenie bufora i wpisanie do niego danych o zdarzeniu
            n = 0;
            while (n<16) {
                    Buff[n] = 0;
                    n++;
            }

            Buff[0] = SrcNr;
            Buff[1] = Data & 0xFF;
            Data = Data>>8;
            Buff[2] = Data & 0xFF;
            Data = Data>>8;
            Buff[3] = Data & 0xFF;
            Data = Data>>8;
            Buff[4] = Data & 0xFF;

            // pomieszanie danych o zdarzeniu z danymi z kolejki
            for (n=0; n<16; n++) Buf2[n] = RandRand[n+RandOffset];
            rijndaelEncrypt(Buf2, Buff);

            // wpisanie nowych danych do kolejki i zamazanie zawartości bufora
            n = 0;
            while (n<16) {
                    RandRand[n+RandOffset] = Buff[n];
                    Buff[n] = 0;
                    n++;
            }
    }

    /*****************************************************************************
    Funkcja generuje 16-bajtowy blok pseudolosowy
    We:
            Adres na blok do wype-nienia wartoťciami losowymi
    Wy:
            blok danych pseudolosowych

    *****************************************************************************/
    public void Rand(int[] Rand, int offset)
    {
            int n;
            int i;
            int[] NewKeyA = new int[16];
            int[] NewKeyB = new int[16];

            // obsługa mieszania z danymi losowymi

            n = 0;
            while (n<32) {                                                      // przejrzenie wszystkich kolejek pod kontem ilości zdarzeń w kolejce
                    if (RandRandCnt[n]>(1L<<n)) {                              // sprawdzenie czy wystarczająco duzo zdarzeń
                            // jesli dość zdarzeń to wymieszanie zdarzeń z kluczem generacji
                            // przekopiowanie aktualnych zdarzeń i wyczyszczenie kolejki
                            i = 0;
                            while (i<8) {
                                    NewKeyA[i] = RandRand[i+(n*16)];
                                    NewKeyB[i] = RandRand[i+8+(n*16)];
                                    NewKeyA[i+8] = 0;
                                    NewKeyB[i+8] = 0;
                                    RandRand[i+(n*16)] = 0;
                                    RandRand[i+8+(n*16)] = 0;
                                    i++;
                            }

                            // wygenerowanie nowego klucza
                            rijndaelEncrypt(RandKeyA, NewKeyA);
                            rijndaelEncrypt(RandKeyB, NewKeyB);

                            // zapisanie nowych kluczy generacji i wyczyszczenie buforów pomocniczych
                            i = 0;
                            while (i<16) {
                                    RandKeyA[i] = NewKeyA[i];
                                    RandKeyB[i] = NewKeyB[i];
                                    NewKeyA[i] = 0;
                                    NewKeyB[i] = 0;
                                    i++;
                            }
                    }
                    n++;
            }

            // przekopiowanie aktualnego stanu licznika
            n = 0;
            while (n<16) {
                    Rand[n+offset] = RandCnt[n];
                    n++;
            }

            // zwiększenie licznika
            RandCnt[0]=(RandCnt[0]+1) & 0xFF;                                        // zwiększenie najmłodszego bajtu
            n = 1;
            while (n<16) {                                                      // sprawdzenie przeniesienia na starszy bajt
                    if (RandCnt[n-1] == 0)                                          // sprawdzenie czy młodszy bajt wyzerowany
                            RandCnt[n]=(RandCnt[n]+1) & 0xFF;                      //  wyzerowany - możliwe tylko gdy nastąpiło przeniesienie -> zwiększenie starszego bajtu
                    else
                            break;                                                      // nie wyzerowany - nie wystąpiło przeniesienie -> koniec pętli
                    n++;
            }

            // wygenerowanei wartości wyjściowej (pseudolosowej)
            rijndaelEncrypt(RandKeyA, Rand);
            rijndaelEncrypt(RandKeyB, Rand);

            // wygenerowanie nowego pierwszego klucza

            // przekopiowanie aktualnego stanu licznika
            n = 0;
            while (n<16) {
                    NewKeyA[n] = RandCnt[n];
                    n++;
            }

            // zwiększenie licznika
            RandCnt[0]=(RandCnt[0]+1) & 0xFF;                                   // zwiększenie najmłodszego bajtu
            n = 1;
            while(n<16) {                                                       // sprawdzenie przeniesienia na starszy bajt
                    if (RandCnt[n-1] == 0)                                      // sprawdzenie czy młodszy bajt wyzerowany
                            RandCnt[n]=(RandCnt[n]+1) & 0xFF;                   //  wyzerowany - możliwe tylko gdy nastąpiło przeniesienie -> zwiększenie starszego bajtu
                    else
                            break;                                              // nie wyzerowany - nie wystąpiło przeniesienie -> koniec pętli
                    n++;
            }

            // wygenerowanie nowego klucza
            rijndaelEncrypt(RandKeyA, NewKeyA);
            rijndaelEncrypt(RandKeyB, NewKeyA);

            // wygenerowanie nowego drugiego klucza

            // przekopiowanie aktualnego stanu licznika
            n = 0;
            while (n<16) {
                    NewKeyB[n] = RandCnt[n];
                    n++;
            }

            // zwiększenie licznika
            RandCnt[0]=(RandCnt[0]+1) & 0xFF;                                   // zwiększenie najmłodszego bajtu
            n = 1;
            while (n<16) {                                                      // sprawdzenie przeniesienia na starszy bajt
                    if (RandCnt[n-1] == 0)                                      // sprawdzenie czy młodszy bajt wyzerowany
                            RandCnt[n]=(RandCnt[n]+1) & 0xFF;                   // wyzerowany - możliwe tylko gdy nastąpiło przeniesienie -> zwiększenie starszego bajtu
                    else
                            break;                                              // nie wyzerowany - nie wystąpiło przeniesienie -> koniec pętli
                    n++;
            }

            // wygenerowanie nowego klucza            
            
            rijndaelEncrypt(RandKeyA, NewKeyB);
            rijndaelEncrypt(RandKeyB, NewKeyB);

            // zapamiętanie nowych kluczy i wyczyszczenie buforów pomocniczych
            n = 0;
            while (n<16) {
                    RandKeyA[n] = NewKeyA[n];
                    RandKeyB[n] = NewKeyB[n];
                    NewKeyA[n] = 0;
                    NewKeyB[n] = 0;
                    n++;
            }
    }
    public void ZeroMemory(int[] ZeroTbl, int size)
    {
        int n;
        for(n=0;n<size;n++) ZeroTbl[n]=0;
    }
}
//-----------------------------------------------------