package ExNvMemWrite;
/**
 *
 * @author TeleVox
 */
import com.televox.TeleToken;

public class ExNvMemWrite {

    public static void main(String[] args) {

        TeleToken TVTT;
        int ret = 0;        
        int n, i;
        int OwnerId = 0x04030200;
        String[] FeatureName ={"Owner ID:               ",
                               "NV Memory size:         ",
                               "Ram size:               ",
                               "Protect memory size:    ",
                               "Password table size:    ",
                               "Bits per password:      ",
                               "Counters:               ",
                               "Bits per counter:       ",
                               "Extension version:      "};
        String stmp;
        int PASS_NO = 32;
        int[][] PassTbl = new int[PASS_NO][16];

        TVTT = new TeleToken();        
        
        for (n = 0; n < PASS_NO; n++) TVTT.ZeroMemory(PassTbl[n], 16);
        n = 0;
        while (n<PASS_NO) {
                stmp = "Pass" + n;
                for(i=0; i<stmp.length(); i++) PassTbl[n][i] = stmp.charAt(i);
                n++;
        }

        //Odczyt wersji biblioteki
        ret = TVTT.GetVersion();

        if (ret==TeleToken.TVTTS_OK) {
            System.out.println("Odczyt wersji biblioteki");
            System.out.println("Wersja pliku : " + TVTT.Version + "." + TVTT.SubVersion);
            System.out.println("Wersja API : " + TVTT.ApiVersion);
        }
        else {
            System.out.println("Błąd odczytu wersji biblioteki : " + String.format("\t%X:%02X",ret>>8,ret&0xFF));
            return;
        }

        //pobranie uchwytu oraz odczyt właściwości tokenu
        ret = TVTT.FindToken(100, OwnerId, 0, 0);
        System.out.print("Otwarcie tokenu:");
        if (ret==TeleToken.TVTTS_OK)
            System.out.println("\t\tOK");
        else
            System.out.println("\t\t" + String.format("%X:%02X",ret>>8,ret&0xFF));

        for(n=0; n<TVTT.FeatureTblSize;n++) System.out.println(FeatureName[n] + "\t" + String.format("0x%02x", TVTT.FeatureTbl[n]));

        // odczytanie nr. seryjnego TeleTokenu
        System.out.print("Odczyt nr. ser. TeleTokenu:");
        ret=TVTT.GetSerialNr(10);
        if (ret==TeleToken.TVTTS_OK)
            System.out.println("     OK");
        else
            System.out.println(String.format("     %X:%02X",ret>>8,ret&0xFF));
            
        System.out.println(String.format("Numer seryjny:\t\t  %02X%02X%02X%02X", TVTT.SerialNr[0], TVTT.SerialNr[1], TVTT.SerialNr[2], TVTT.SerialNr[3]));
        
        // zainicjowanie OutKey
        TVTT.OutKey = (int) (System.currentTimeMillis() & 0xFFFFFF00) | 0xF00;

        // rozpoczecie sesji
        System.out.print("Rozpoczecie sesji:");
        ret = TVTT.StartSession(1);
        if (ret != 0)
            System.out.println(String.format("     %X:%02X",ret>>8,ret&0xFF));
        else
            System.out.println("\t      OK");

        // otwarcie sesji
        System.out.print("Otwarcie sesji:");

        TVTT.ZeroMemory(TVTT.OutDataA, 16);
        TVTT.ZeroMemory(TVTT.OutDataB, 16);
        TVTT.ZeroMemory(TVTT.InDataA, 16);
        TVTT.ZeroMemory(TVTT.InDataB, 16);

        TVTT.OutKey = 0;                                                        // znacznik wiadomości nie szyfrowanej
        TVTT.Rand(TVTT.OutDataA, 0);                                            // wylosowanie tablicy losowej
        TVTT.OutDataB[TeleToken.TVTTD_CMD] = TeleToken.TVTTC_OPEN;              // rozkaz otwarcia sesji
        TVTT.OutDataB[TeleToken.TVTTD_PARAM1] = 0;                              // numer hasła proponowanego przez PC

        TVTT.Calc(TVTT.OutDataA,  TVTT.OutDataB);                               // policzenie bloku kontrolnego
        ret = TVTT.Talk(1);
        TVTT.CalcSessionKey(TVTT.SessionKey,                                    // policzenie klucza sesji
                            PassTbl[TVTT.OutDataB[TeleToken.TVTTD_PARAM1]],
                            TVTT.OutDataA,
                            PassTbl[TVTT.InDataB[TeleToken.TVTTD_PARAM1]],
                            TVTT.InDataA);
        if (ret != 0)
            System.out.println("\t\t " + String.format("%X:%02X",ret>>8,ret&0xFF));
        else {
            if (TVTT.Check(TVTT.InDataA, TVTT.InDataB) != 0)
                System.out.println("\t\t Blad bloku kontrolnego!");
            else {
                if (TVTT.InDataB[TeleToken.TVTTD_STATUS] != 0)
                    System.out.println("\t\t " + String.format("%02X", TVTT.InDataB[TeleToken.TVTTD_STATUS]));
                else
                    System.out.println("\t\t OK");
            }
        }

        // zainicjowanie OutKey
        TVTT.OutKey = (int) (System.currentTimeMillis() & 0xFFFFFF00) | 0xF00;

        // zapis pamięci TeleTokenu
        System.out.print("Zapis pamięci TeleTokenu:");

        n = 0;
        while (n<TVTT.FeatureTbl[TeleToken.TVTTTI_NV_MEM_SIZE])
        {
            TVTT.ZeroMemory(TVTT.OutDataA, 16);
            TVTT.ZeroMemory(TVTT.OutDataB, 16);
            TVTT.ZeroMemory(TVTT.InDataA, 16);
            TVTT.ZeroMemory(TVTT.InDataB, 16);

            TVTT.OutKey++;                                                      // zwiększenie licznika kluczy

            TVTT.OutDataB[TeleToken.TVTTD_CMD] =
                          TeleToken.TVTTC_NVMEM_WRITE;                          // rozkaz zapisu pamięci TeleTokenu
            TVTT.OutDataB[TeleToken.TVTTD_PARAM1]= n;                           // numer sektora do zapisania

            // wypełnienie bufora danymi do zapisania
            i = 0;
            while (i<16) {
                TVTT.OutDataA[i] = ((i<<4) | n) & 0xFF;
                i++;
            }

            TVTT.Calc(TVTT.OutDataA, TVTT.OutDataB);                            // policzenie bloku kontrolnego
            TVTT.CryptBlock(TVTT.OutDataA, TVTT.OutKey,                         // zaszyfrowanie pierwszego bloku danych
                            TVTT.SessionKey, TeleToken.TVTT_BLOCK_A,
                            TeleToken.TVTT_PC2T);
            TVTT.CryptBlock(TVTT.OutDataB, TVTT.OutKey,                         // zaszyfrowanie drugiego bloku danych
                            TVTT.SessionKey, TeleToken.TVTT_BLOCK_B,
                            TeleToken.TVTT_PC2T);
            ret = TVTT.Talk(2);
            TVTT.CryptBlock(TVTT.InDataA, TVTT.InKey,                           // rozszyfrowanie pierwszego bloku danych
                            TVTT.SessionKey, TeleToken.TVTT_BLOCK_A,
                            TeleToken.TVTT_T2PC);
            TVTT.CryptBlock(TVTT.InDataB, TVTT.InKey,                           // rozszyfrowanie drugiego bloku danych
                            TVTT.SessionKey, TeleToken.TVTT_BLOCK_B,
                            TeleToken.TVTT_T2PC);

            if (ret != 0) {
                System.out.println("\t\t" + String.format("%X:%02X",ret>>8,ret&0xFF));
                break;
            }

            if (TVTT.Check(TVTT.InDataA, TVTT.InDataB) != 0) {
                System.out.println("\tBlad bloku kontrolnego!");
                break;
            }

            if (TVTT.InDataB[TeleToken.TVTTD_STATUS] != 0) {
                System.out.println("\t\t" + String.format("%02X", TVTT.InDataB[TeleToken.TVTTD_STATUS]));
                break;
            }

            if (TVTT.InKey == 0) {                                       // sprawdzenie czy wiadomość zaszyfrowana
                System.out.println("\tWiadomosc nie zaszyfrowana!\n");
                break;
            }

            n++;
        }
        if (n >= TVTT.FeatureTbl[TeleToken.TVTTTI_NV_MEM_SIZE]) System.out.println("       OK");

        // zamknięcie sesji
        System.out.print("Zamkniecie sesji:");
        TVTT.ZeroMemory(TVTT.OutDataA, 16);
        TVTT.ZeroMemory(TVTT.OutDataB, 16);
        TVTT.ZeroMemory(TVTT.InDataA, 16);
        TVTT.ZeroMemory(TVTT.InDataB, 16);

        TVTT.OutKey++;
        TVTT.OutDataB[TeleToken.TVTTD_CMD] = TeleToken.TVTTC_CLOSE;             // rozkaz zakończenia sesji

        TVTT.Calc(TVTT.OutDataA,  TVTT.OutDataB);                               // policzenie bloku kontrolnego
        TVTT.CryptBlock(TVTT.OutDataA, TVTT.OutKey,                             // zaszyfrowanie pierwszego bloku danych
                        TVTT.SessionKey, TeleToken.TVTT_BLOCK_A,
                        TeleToken.TVTT_PC2T);
        TVTT.CryptBlock(TVTT.OutDataB, TVTT.OutKey,                             // zaszyfrowanie drugiego bloku danych
                        TVTT.SessionKey, TeleToken.TVTT_BLOCK_B,
                        TeleToken.TVTT_PC2T);
        ret = TVTT.Talk(1);
        if (ret != 0)
            System.out.println("\t       " + String.format("%X:%02X",ret>>8,ret&0xFF));
        else
            System.out.println("\t       OK");

        // zakończenie sesji
        System.out.print("Zakonczenie sesji:");
        ret = TVTT.EndSession();
        if (ret != 0)
            System.out.println("\t      " + String.format("%X:%02X",ret>>8,ret&0xFF));
        else
            System.out.println("\t      OK");

        //zwolnienie uchwytu i zasobów, zamknięcie dostępu do tokenu
        ret = TVTT.FreeToken();
        System.out.print("Zamknięcie dostępu do tokenu: ");
        if (ret==TeleToken.TVTTS_OK)
            System.out.println("  OK");
        else
            System.out.println(String.format("  0x%2x", ret));
    }
}
